function a = apiter(x,LL,elle)

% ------------------------------
% Author: Filippo Ferroni, UPF.
% Date  : 7-12-2008
% ------------------------------


% APITER reduces randomly the dimensionality of \verb"theta". This program
% throws the LL rows of the matrix x, and then picks randomly one row every 
% elle rows. This program basically is aimed to remove the correlation 
% between draws created by the Markov Chain of the RWM algorithm.

v = size(x);

dai=(v(1)-LL)/elle;

a=zeros(dai,v(2));

for  j = 1:v(2)
    for i = 1:dai
        s = fix(unifrnd(1,elle));
        a(i,j)=x(LL+elle*(i-1)+s,j);
    end    
end
