% ------------------------------
% Author: Filippo Ferroni, UPF.
% Date  : 7-12-2008
% ------------------------------

% MAIN_POSTERIOR.m is the main program that produces several graphs; mainly 
% the CUMSUM statistics plots, the prior-postrior distributions for each 
% setup.  
% We conseder two types of estimation approaches: two step, where data are
% first filtered and then DSGE structural parameters are estimated, and one
% step, where structural and filtering parameters are jointly estimated
nomi.est  = strvcat('2s','1s');
% Consider three filters: linear detrending, HP filter and first
% difference.
nomi.filt = strvcat('lt','hp','fd');
% Thus, we have 6 different setups. The output (graphs) are stored in the 
% folder .\POSTERIOR\graphs. Details on the computation of CUMSUM 
% statistics or the prior-postrior distributions are reported in the m.file
% posterior.m.

% The set of structural parameters:
nomi.rnames = strvcat('\sigma_c','\sigma_n','\rho_r','\rho_{\pi}',...
    '\rho_{y}','\zeta_p','\rho_{\chi}','\rho_{z}',...
    '\sigma_{\chi}','\sigma_{z}','\sigma_{mp}', '\sigma_{\mu}'); 

% Number of structural parameters:
struct = size(nomi.rnames,1);

for e=1:size(nomi.est,1)
    for filo=1:size(nomi.filt,1)
        load(['.\output\' num2str(nomi.est(e,:)) '_output_' ...
             num2str(nomi.filt(filo,:)) '.mat'],'theta_p','loglike_p','N','data')
        posterior;
        clear theta_p loglike_p N data
    end
end
clear all