% We conseder two types of estimation approaches: two step, where data are
% first filtered and then DSGE structural parameters are estimated, and one
% step, where structural and filtering parameters are jointly estimated
nomi.est  = strvcat('2s','1s');
% Consider three filters: linear detrending, HP filter and first
% difference.
nomi.filt = strvcat('lt','hp','fd');
% Thus, we have 6 different setups.

para.struct = strvcat('\sigma_c','\sigma_n','\rho_r','\rho_{\pi}','\rho_{y}',...
    '\zeta_p','\rho_{\chi}','\rho_{z}',...
    '\sigma_{\chi}','\sigma_{z}','\sigma_{mp}', '\sigma_{\mu}');

para.lt = strvcat('\sigma_c','\sigma_n','\rho_r','\rho_{\pi}','\rho_{y}',...
    '\zeta_p','\rho_{\chi}','\rho_{z}','\sigma_{\chi}','\sigma_{z}',...
    '\sigma_{mp}', '\sigma_{\mu}', '\sigma_y^{\eta}', '\sigma_n^{\eta}', ...
    '\sigma_{\omega}^{\eta}', '\sigma_{\pi}^{\eta}','B_y','B_n','B_{\omega}', 'B_{\pi}'); 

para.hp = strvcat('\sigma_c','\sigma_n','\rho_r','\rho_{\pi}','\rho_{y}',...
    '\zeta_p','\rho_{\chi}','\rho_{z}','\sigma_{\chi}','\sigma_{z}',...
    '\sigma_{mp}', '\sigma_{\mu}', '\sigma_y^{\zeta}', '\sigma_n^{\zeta}', ...
    '\sigma_{\omega}^{\zeta}', '\sigma_{\pi}^{\zeta}'); 

para.fd = strvcat('\sigma_c','\sigma_n','\rho_r','\rho_{\pi}','\rho_{y}',...
    '\zeta_p','\rho_{\chi}','\rho_{z}','\sigma_{\chi}','\sigma_{z}',...
    '\sigma_{mp}', '\sigma_{\mu}', '\sigma_y^{\eta}', '\sigma_n^{\eta}', ...
    '\sigma_{\omega}^{\eta}', '\sigma_{\pi}^{\eta}','\gamma_y','\gamma_n','\gamma_{\omega}','\gamma_{\pi}'); 

for e=1:size(nomi.est,1)
    for filo=1:size(nomi.filt,1)
        load(['stat_' num2str(nomi.est(e,:)) '_' num2str(nomi.filt(filo,:)) '.mat' ])
        fid21=fopen(['Posterior_' num2str(nomi.est(e,:)) '_'...
            num2str(nomi.filt(filo,:)) '.txt'],'w');
        fprintf(fid21,'%s\r ','\begin{table}');
        fprintf(fid21,'%s\r ','\centering');
        fprintf(fid21,'%s\r ','\begin{tabular}{c|ccccc}');
        fprintf(fid21,'%s\r ','$\theta$ & mean & median & sd & 95\% & 5\% \\');
        fprintf(fid21,'%s\r ','\hline');
        fprintf(fid21,'%s\r ','\hline');
        if strcmp(nomi.est(e,:),'2s')==1,
            for ff=1:size(para.struct,1)
                fprintf(fid21,'%s ','$');
                fprintf(fid21,'%s ',num2str(para.struct(ff,:)));
                fprintf(fid21,'%s ','$');
                for i=1:size(stat,2)
                    fprintf(fid21,'%s ','&');
                    fprintf(fid21,'%6.4f',stat(ff,i));
                end
                fprintf(fid21,'%s\r ','\\');
            end
        elseif strcmp(nomi.est(e,:),'1s')==1 && strcmp(nomi.filt(filo,:),'lt')==1,
            for ff=1:size(para.struct,1)
                fprintf(fid21,'%s ','$');
                fprintf(fid21,'%s ',num2str(para.(nomi.filt(filo,:))(ff,:)));
                fprintf(fid21,'%s ','$');
                for i=1:size(stat,2)
                    fprintf(fid21,'%s ','&');
                    fprintf(fid21,'%6.4f',stat(ff,i));
                end
                fprintf(fid21,'%s\r ','\\');
            end
        elseif strcmp(nomi.est(e,:),'1s')==1 && strcmp(nomi.filt(filo,:),'hp')==1,
            for ff=1:size(para.struct,1)
                fprintf(fid21,'%s ','$');
                fprintf(fid21,'%s ',num2str(para.(nomi.filt(filo,:))(ff,:)));
                fprintf(fid21,'%s ','$');
                for i=1:size(stat,2)
                    fprintf(fid21,'%s ','&');
                    fprintf(fid21,'%6.4f',stat(ff,i));
                end
                fprintf(fid21,'%s\r ','\\');
            end

        elseif strcmp(nomi.est(e,:),'1s')==1 && strcmp(nomi.filt(filo,:),'fd')==1,
            for ff=1:size(para.struct,1)
                fprintf(fid21,'%s ','$');
                fprintf(fid21,'%s ',num2str(para.(nomi.filt(filo,:))(ff,:)));
                fprintf(fid21,'%s ','$');
                for i=1:size(stat,2)
                    fprintf(fid21,'%s ','&');
                    fprintf(fid21,'%6.4f',stat(ff,i));
                end
                fprintf(fid21,'%s\r ','\\');
            end
        end
        fprintf(fid21,'%s\r ','\hline');
        fprintf(fid21,'%s\r ','\hline');
        fprintf(fid21,'%s\r ','\end{tabular}');
        fprintf(fid21,'%s ','\caption{Posterior Statistics for the');
        fprintf(fid21,'%s ',num2str(nomi.est(e,:)));
        fprintf(fid21,'%s ','approach using the');
        fprintf(fid21,'%s ',num2str(nomi.filt(filo,:)));
        fprintf(fid21,'%s\r ','filter.}');
        fprintf(fid21,'%s\r ','\end{table}');
        fclose(fid21);
    end
end
