function [sigmac,sigman,rhor,rhopi,rhoy,zetap,rhochi,rhoz]=trans(theta)

% ------------------------------
% Author: Filippo Ferroni, UPF.
% Date  : 7-12-2008
% ------------------------------

% TRANS calls the structural parameters of the DSGE model from the
% parameter vector. 

sigmac = theta(1);      % elasticity of consumption
sigman = theta(2);      % elasticity of labor
rhor   = theta(3);      % autoregressive component in the monetary rule
rhopi  = theta(4);      % coefficient on inflation in the monetary rule
rhoy   = theta(5);      % coefficient on ouput in the monetary rule
zetap  = theta(6);      % probability of keeping price fixed
rhochi = theta(7);      % AR coefficient in the preference process
rhoz   = theta(8);      % AR coefficient in the technology process
